!+ Subroutine to read an unformatted TAPE7 file.
!
! Method:
!	Straightforward.
!
! Current Owner of Code: J. M. Edwards
!
! History:
!	Version		Date			Comment
!	1.0		12-04-95		First Version under RCS
!						(J. M. Edwards)
!
! Description of Code:
!   FORTRAN 77  with extensions listed in documentation.
!
!- ---------------------------------------------------------------------
      SUBROUTINE READ_TAPE7_UNFORM(N_WAVENUMBER_TRANS, TRANS_CONTINUUM)
!
!
      IMPLICIT NONE
!
!
!     INCLUDE HEADER FILES.
      INCLUDE 'incl/dimensions_spec.ucf'
      INCLUDE 'incl/dimensions_pp.ucf'
      INCLUDE 'incl/def_std_io.icf'
      INCLUDE 'incl/def_lwtrn_io.icf'
      INCLUDE 'incl/continuum.pcf'
      INCLUDE 'incl/lowtran_parameters.ecf'
!
!     DUMMY ARGUMENTS
      INTEGER	!, INTENT(IN)
     &     N_WAVENUMBER_TRANS
!             NUMBER OF WAVENUMBERS
      REAL*8	!, INTENT(OUT)
     &     TRANS_CONTINUUM(NPD_WAVENUMBER_TRANS, NPD_CONTINUUM)
!             CONTINUUM TRANSMITTANCES
!
!     LOCAL VARIABLES.
      REAL*8
     &     TRANS_DUMMY(NPD_COLUMN_TAPE7)
!             LOWTRAN TRANSMITTANCES
     &   , WAVENUMBER_DUMMY
      CHARACTER
     &     HMODEL(5, 8)*4
!             LOWTRAN CHARACTER NAME
      INTEGER
     &     I
!             LOOP VARIABLE
     &   , J
!             LOOP VARIABLE
     &   , FEND
!             LOWTRAN END FLAG
      INTEGER
     &     MODEL
!             LOWTRAN VARIABLE
     &   , ITYPE
!              "
     &   , IEMSCT
!              "
     &   , IMULT
!              "
     &   , M1, M2, M3, M4, M5, M6
!              "
     &   , MDEF
!              "
     &   , IM
!              "
     &   , NOPRT
!              "
     &   , IHAZE
!              "
     &   , ISEASN
!              "
     &   , IVULCN
!              "
     &   , ICSTL
!              "
     &   , ICIR
!              "
     &   , IVSA
!              "
     &   , ISEED
!              "
     &   , ML
!              "
      INTEGER
     &     IPARM
!              "
     &   , IPH
!              "
     &   , IDAY
!              "
     &   , ISOURC
!              "
     &   , LEN
!              "
     &   , IPRT
!              "
      REAL*8
     &     TBOUND
!              "
     &   , SALB
!              "
     &   , VIS
!              "
     &   , WSS
!              "
     &   , WHH
!              "
     &   , RAINRT
!              "
     &   , GNDALT
!              "
     &   , CTHIK
!              "
     &   , CALT
!              "
     &   , CEXT
!              "
     &   , ZCVSA
!              "
     &   , ZTVSA
!              "
     &   , ZINVSA
!              "
      REAL*8
     &     H1
!              "
     &   , H2
!              "
     &   , ANGLE
!              "
     &   , RANGE_1
!              "
     &   , BETA
!              "
     &   , RO
!              "
     &   , P
!              "
     &   , T
!              "
     &   , DP
!              "
     &   , RH
!              "
     &   , WH
!              "
     &   , WO
!              "
      REAL*8
     &     PARM1
!              "
     &   , PARM2
!              "
     &   , PARM3
!              "
     &   , PARM4
!              "
     &   , TIME
!              "
     &   , PSIPO
!              "
     &   , ANGLEM
!              "
     &   , G
!              "
     &   , V1
!              "
     &   , V2
!              "
     &   , DV
!              "
!
!
!     READ THE HEADER CARDS.
      READ(IU_LOWTRAN_TAPE7)
     &     MODEL, ITYPE, IEMSCT, IMULT, M1, M2, M3, M4, M5, M6
     &   , MDEF, IM, NOPRT, TBOUND, SALB
      READ(IU_LOWTRAN_TAPE7)
     &     IHAZE, ISEASN, IVULCN, ICSTL, ICIR, IVSA
     &   , VIS, WSS, WHH, RAINRT, GNDALT
      READ(IU_LOWTRAN_TAPE7) CTHIK, CALT, CEXT, ISEED
      READ(IU_LOWTRAN_TAPE7) ZCVSA, ZTVSA, ZINVSA
      READ(IU_LOWTRAN_TAPE7) ML, (HMODEL(I,7), I=1, 5)
      IF (MODEL.NE.0) THEN
         READ(IU_LOWTRAN_TAPE7)
     &      H1, H2, ANGLE, RANGE_1, BETA, RO, LEN
      ELSE
         READ(IU_LOWTRAN_TAPE7)
     &      H1, P, T, DP, RH, WH, WO, RANGE_1
      ENDIF
      READ(IU_LOWTRAN_TAPE7) IPARM, IPH, IDAY, ISOURC
      READ(IU_LOWTRAN_TAPE7) PARM1, PARM2, PARM3, PARM4
     &   , TIME, PSIPO, ANGLEM, G
      READ(IU_LOWTRAN_TAPE7) V1, V2, DV
      READ(IU_LOWTRAN_TAPE7) IPRT
!
!     N_WAVENUMBER_TRANS IS ALREADY KNOWN HERE.
      DO I=1, N_WAVENUMBER_TRANS
         READ(IU_LOWTRAN_TAPE7)
     &      WAVENUMBER_DUMMY
     &      , (TRANS_DUMMY(J), J=1, NPD_COLUMN_TAPE7)
!        TRANSFER THE CONTINUUM VALUES TO THE OUTPUT ARRAYS.
         TRANS_CONTINUUM(I, IP_N2_CONTINUUM)
     &      =TRANS_DUMMY(LOWTRAN_N2_CONTINUUM)
         TRANS_CONTINUUM(I, IP_SELF_CONTINUUM)
     &      =TRANS_DUMMY(LOWTRAN_SELF_CONTINUUM)
         TRANS_CONTINUUM(I, IP_FRN_CONTINUUM)
     &      =TRANS_DUMMY(LOWTRAN_FRN_CONTINUUM)
      ENDDO
!
!     READ THE TERMINATION FLAG.
      READ (IU_LOWTRAN_TAPE7) FEND
!
!
      RETURN
      END
